// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	"github.com/pkg/errors"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Architecture to use for the compose. If left empty the host arch
	// will be used.
	Architecture *string `json:"architecture,omitempty"`

	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeList defines model for ComposeList.
type ComposeList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []ComposeStatus `json:"items"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// DistributionList defines model for DistributionList.
type DistributionList struct {
	// Distribution name
	Map *DistributionList_Map `json:"map,omitempty"`
}

// Distribution name
type DistributionList_Map struct {
	AdditionalProperties map[string]interface{} `json:"-"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// SearchPackagesRequest defines model for SearchPackagesRequest.
type SearchPackagesRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchPackagesResponse defines model for SearchPackagesResponse.
type SearchPackagesResponse struct {
	// Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostSearchPackagesJSONBody defines parameters for PostSearchPackages.
type PostSearchPackagesJSONBody SearchPackagesRequest

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody PostSearchPackagesJSONBody

// Getter for additional properties for DistributionList_Map. Returns the specified
// element and whether it was found
func (a DistributionList_Map) Get(fieldName string) (value interface{}, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for DistributionList_Map
func (a *DistributionList_Map) Set(fieldName string, value interface{}) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]interface{})
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for DistributionList_Map to handle AdditionalProperties
func (a *DistributionList_Map) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]interface{})
		for fieldName, fieldBuf := range object {
			var fieldVal interface{}
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return errors.Wrap(err, fmt.Sprintf("error unmarshaling field %s", fieldName))
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for DistributionList_Map to handle AdditionalProperties
func (a DistributionList_Map) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, errors.Wrap(err, fmt.Sprintf("error marshaling '%s'", fieldName))
		}
	}
	return json.Marshal(object)
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The list of composes
	// (GET /composes/)
	GetComposeList(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get all of the supported distribution repository details
	// (GET /distributions)
	GetDistributionList(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeList converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeList(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetDistributionList converts echo context to params.
func (w *ServerInterfaceWrapper) GetDistributionList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetDistributionList(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/", wrapper.GetComposeList)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/distributions", wrapper.GetDistributionList)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPbOLL4V0Hpl6pMXnTfdtXUPlm+ZFu+5CP2KuWFSEiCRQI0AEqW5+W7/woHKVKi",
	"rjiZ2dnNH7sTizgaDXSjb/yRsqjrUYKI4KndP1IeZNBFAjHz1wDJ/9qIWwx7AlOS2k1dwgECmNjoNZVO",
	"oVfoeg6KNR9Dx0ep3VQh9e1bOoVlnxcfsWkqnSLQlV9Uy3SKW0PkQtlFTD35OxcMk4HqxvFbwtznvttD",
	"DNA+wAK5HGACELSGwAwYhSYYIIQmn18Kj2q7Cp5vwUc1dOO+c9AsNh1KUFOij6uJoG1jCSZ0Lhn1EBNY",
	"AtKHDkfplBf56Y8UQwO1noWJ0ik+hAw9TbAYPkHLor7ZGLOy1O4/U4ViqVyp1uo7+UIx9TWdUphIHMv8",
	"ABmDU7V2hl58zJAthzEwfA2b0d4zsoTsp9d36zkU2hcK9fy7FxgCnkJ+ZoK4yBRS6T9z2ekUJ9DjQyqe",
	"9G5HYXKnmeDrIlTJCEuGdR0aOwIKX1NJDFHQxXGIoIszeateytd2SrVapbJTscu9JIxtieK5xch502vO",
	"QKf0niPg+T0HW5qE+9B3RNguTtKtPuBIAEGB+gx+E0METBegiPdTGkDgUDJIA9rr+9yCAtng9vqsSzAH",
	"DAmfEWRnQUtwgF49zKAcGrh4MBSghwCnlCAGxBAS0KcMUDFEDPhqbV0iIBsgwbNd0iUzWATzkZyWDykT",
	"iMnZQGQyAIndJTg+IeZAws6hiwDkair5d3Q6MJtttkU9Sh0Eyfs3dbPtXHYUfeYks+LoFLJR4vhvPkPv",
	"OS7DqYfY0/hpgAjS+IwdndSdXH785DSHlHKkcHzXBi1X3kvHcpg7MBslDWzc7yOGiAB9BIXPEAeUAAUw",
	"gPJ/Y4gd2HNQl9jIQ8TGZCBbyHEXhtMbh4jvSmwooO6KEYzM6BNLeEKWM3eNySNC+2oKfTCQDVQHeYqB",
	"63N1cH2CX3x516qGAzxGBDDEqc8sBAaM+l5WnVk5iTx91MVCkkafUVd1kTuHuJAHmUFiUxdQgkAPcmTL",
	"FUJwe9vaB5h3iVkhss0CoxxSAZbEghxqRXYqusAz8yVYpMfoGMtFBuA/KfDTYDJETG+hmkXSm+/YavEB",
	"XiCR3QaYC8QUfMd0IknUwVwA6DggAIPvdslQCI/v5nI2tXjWxRajnPZF1qJuDpGMz3OWg3NQ7n3O8O5/",
	"jDGa/K5+ylgOzjhQIC7+H3wLmPuTnOgpnOSjQrmEOPhJop5QAbiHLNzHyE4DLOSPNrJ9K7YhS/Awj3RJ",
	"78iX9JHM+aN9V5+u+HHZAN3zoNxQ34Lk2gxzpGZMur/9XgjCE7YXgWrtS5Cizb4DmDKq2PVe0crAXrGc",
	"KZcLpcxO3qpkqoViKV9F9fwOKiZBJxCBRKyASwKhG20GlTmCfUxstdeaQjVPuaRMQGeTsxicQ4HHKGNj",
	"hixB2TTX94kNXUQEdPjC18yQTjKCZuTUGQ3yHJIqVg31K71qpmCV+pmyDfMZWC0WM/levpovlnbsml1b",
	"e5XMMLa4twsncM2FsOzCiXPITVjOHJCRAZJA2HN85DFMxJZXEWTWEAtkybti8cA0Il/lGfA5Cq96S2sD",
	"WdDqAwf1BUCuJ6bq05BKbsWsYZdMsOOo88QXT/hrvfpULSedYYsSATExqtncTRh802eWS7iQ25OXCpHC",
	"zBDJowodAJnoQ0vKuqH4/IGhfmo39f9yM00wZ3SdXDhuklht+VxQF7/B8LpfNVS4Gc14t29zt3qCPG9j",
	"LhhdXPWNFBTlN9zzFUPZbje6RA8MVu1HH9mUwUxpJ2lL1OnnSRqyNZKsQ3+XYPXkLc4FdBxkb4p8M4pm",
	"uQn4d6ntG1137oQSAB1sJFBPj8LTUnaVe2mrn3vQGk0gs7nCEhSwhx0spmr120CXBFhA0Qv4CmBZirH3",
	"4ioJmjFiPFFGaQCO3DFiwLQARBkXYttfy9aytfxaRrSeBTUXiGULhmRBCzGxnlobTdksNpWmH3134CTM",
	"788+SuRbDEERipwh08DbcI1gyGnSdvRtuq7/4f6FaokTT/eh/PlHgRrujxw1EVw525QL5CYIuVIApX0w",
	"awNcKTB6FBMRAfG7gDGTJoKUxHMOiFRhwGHrsgNcaqNE9bKPGZpAx9kCEtMh4HbLsTBjdtuteil/kzw6",
	"WX1qUtLHA6XJBcxcNUzSwgYEBxfLKihaQTtlIVTcR9HPk43G2FqjwkU7AN0hDSyfSaXTmQJKnKm8XPq+",
	"E95NyB6gDMeu5yiNIRNwPAbkEuYuoZyNxjluw8QFBh3XrjBs+C2dGiFG0NpjcKpbGU3PQevan+lW39Ip",
	"6iHCLehtfNAuPEQ6zcalviaYUJuByeBJneWYJQD6gmacsbtgD+ggB1kCDKVsrkWDkZHhgxs+HBnZWfAx",
	"GOij/i5FBwYnwCcO4rxLhFIEIENKaaYMuJShGIVjqcNgawgsyJHUA8Jxzu7aWfBRjQ2dCZzyLvE54vL3",
	"NEBSj58MkWJcZgpCAXoVDEbHz4KPDE4+AtVTQhaCz7skaZAlcMZtFgxOUumUxl+Iyq+JaqZHOV52b1xH",
	"vkqinzAslDycQ8LKTX03q/pn7VycQxsrxzkVSKIYCvmNB0gQSggDUICejx0bCOyi7OZCSXicQugS7yA2",
	"5O66oa6PO+2Fm5R56/tdLnbjiEmesBb8TtBO9uHDEZouZ7ecD8EITfmmqOl0jk9RIjYkjt8oWUvdN0G7",
	"b+mUzzXDSYZNfn3P/XfLkzSOb6vkK3V/J4h4WklRV/Q6mUGfs7jkZUMBk9UtCXnA/9XokAPPgXJk9CqW",
	"aguLg6n7b34kCAbYlrQMjeHG3G+zO4FR5bKgBF30U7v/XJS2w18wEWggEfpVKw1JLj3EXMylEMyBHiC8",
	"qBREmABqCaiuLxeKGCD5ajlRX/WgGCYJ+mIIQpXUia9JsQ53an5fGDH50F1MiPYIxvHnB/iTvX4Q+uak",
	"frXCr+tO5Ux6jB8tF5NkH6f8NboeI1piAnpTgXh0GcVCuVaul6rlejr1mhnQjAHFx0RUy1pJDK6BuI0l",
	"N4ZsrVoT6ZwO4V2z4JmAuVLBmZfpdTcbWEa007xzwadEjRqUzHfUZ/Cb1HopE4BBMkD8kzIge4wKalFH",
	"sSUpnUTR+M9UsbgrLC+VTtXz5h/YhZ7653auxg05fbDgKMeXvFXbxTZhlsEIj6rXdswyFLYWDqXkd1ww",
	"BN3E5T5zSp4ExA5Vv6wBMZjmpHNxfhN2kqyBOtiaJppjL30hqTc0pQPdFrT2A6YtL2Yg+TVPAy4ZCRQA",
	"kqkWwoklRaXQWQAE7RJ5bgdDwUMpUEo9LhTYgo4zlSeOIGWlN2xJrsTBcqhgcjOzRQmnjpFHDCfcTfm+",
	"Moku8j9GJfWaVS6enG2xGMHgPB+azbSSOCNC0cLG9yBHPnPi52/GLgJTtmWTLEP2EGoztqUvwpyNucix",
	"IXLquXpOmzBzckTKc5TnYthiONFAP0dHSGmzUczFtFgHLbUxDbyBNUTWKLnrwBsooSm6yrXALNlBFwno",
	"YDJKxpSLGaOMZ7UB0WNUbkeWskEu6PcPKSD/HhgYi10/ny9WIbOGv4dG4HVo05M4mItFIEIY5OeshYig",
	"XM3/D4YcBDn6vZ7RpB6ZGcr/r5b1Lwq+PcjRRWcTWJQ58mlIRR+/JluauNxUDlRLyLCYyvtNoIi8oVzs",
	"wSld5iRfbl9kmMphIx/D21vrM0+rjwfnzhgx3J8mfZ53PqyhtlsjrWxh51tnCB8kcUwtP2I7sH5LPoig",
	"HUgQgd6cTsDIMvt1Q/tWaR/MgI/Yd6Bta8+1lKwEjYr3syOomhc2ofUhTbLx3JgJPnIgG4DQAZY0ZKKm",
	"JDUkHYQiFaWY9Mf5MIPsYqVS2AGNRqPRLJ2/wWbBedxvFc5vDiryt9Y5Ozo9YO0H/Lndvp34x/C6ceJe",
	"n9HW23W/+LJftPcrb/m9m9dc9TUJpkW/llxOIVlU5nxCWZJ30rjPTQPABWTqJhND8KH6IQ0+VD6kpZz7",
	"odj7EFogeghwQeX9B3mXQAIQsdjUk3dcMFIWXIghYhMcMVz0EBBKP7K1CD1TZ7ok7BelyWj4FtJC33wY",
	"wAAToD6a45ko1ycda0k+33OqN7XMJxrLt4xwQu5TaJiPCJOZTGbv4Kh1DpoH1zetw1azcXOQyWS6XdJu",
	"tZr5/Waz0cODxqS11xi0blvZbLbbJZlM5uB8f67LO8L7ZsAlrj4Su7hHbUU9M11olTiSEPuoFMvoL9eI",
	"e5SYqEjH2WDUCwXZNVKBOhZS+tecs9iOE1OhWELlSrWWQfWdXqZQtEsZWK5UM+VitVqplMv5fD6/Xkzb",
	"hKeHq5v5sb9/Uavax7zlelqNz5b9H4RJvaQzI7NstijVOmElAWls6MxWMwf4XUM/esjVa6AD/kM3RoUz",
	"KMNnooRqQIir+pLxsT600B/fki7XEX3Ga8389BmrtSTHVxiAVqKiDQnuIy5+KD7c6KDvR8a8cSMcffXK",
	"kICBFfBHLYxKuRs9WdR1sUgMSfptCPnwU3DbyR0QwDRPf4dfXctzmFiOr6Ibzw/urhtb+tZDRGxga4jg",
	"71qHIK69WgkVOnB8tkNzASbpVC8M6Pn6bf4y7kWDfTayMm8fw5IQuhIJP4lzVakNZ+qppYGhbIaXlV47",
	"2TjA4XznzXnf/DDfyyYWqCiGgMi2d/Yu2j+WOQbLXFQT5FzAppbvKqO81CRVUoj2/WniCU04OiQoevY3",
	"GnAWgGscWAezGXzuK0vSUEnbAkjtWgAxoWognlZ+uWAQ7ddCZIwZJXJ8ZZ6MtOgSaAkfOsAYV0Ins5p3",
	"U6JVGy6nT/T4vPPi+xGCUNLVx8Nx1y8tvMWjXdGWFLFMFtAEsSE8ki5mA23WJ4bIO5WhNL8PZqD4AjfZ",
	"lwPGKEsw7SIBsTLwzZu0YjYSyBOND4viXdh4AQC9HskNjcuZ+5aFuFxLH2LHZ1ILNIH2ckERvTxsuMA1",
	"Z6GICytbEWO/EBEYxEmGEdlLg9t1hGuS49sc45m9OBg0iLqMe5qUNZpNs+YnZThVs+4KOEg0kDj8aWaG",
	"WnQ9MuqAm7MOUG1wH1uBsyScVGWvrDNgmQUmqofBkt6T0bFiW8L9MOYGKx6/Ohf+QrlimomogoMEFg4H",
	"W86gY/4TlZp1uInwwi0MfXhg7v55E6n8PeD4gYS6kCkyW4xJUwnOWLJxxiT2zLncrvbPk1NQ5nDz4sNp",
	"FtOcOzX5EDmzH7srsDafMpQOlpx42pRYtYF34t/EOaEMyE8Db5BsRNafA2tzcpt3+TeMtfOXA+OnOzB+",
	"mO+Bc+fpvZ6FvzKEOJ588KNyB55Wh5gdqIC4aJtYRHvESYwJiGtyWXAzRBx1Sax3NNBfXtY28jh1xsik",
	"mAmG0RiF42dBI8SvM02rgEA++zwztcOxyVLDrkdZxJP8r4VYuH/N/BhdYpj3jOluhtd5bpmA3rmI778k",
	"anvDKIZNwq43Hmp90PTKEVqXnW2ipIMQjAVqWeZX+7cKlY7mW/2KoP7bRlDHA6dndsCIP8qjXAwY4tuF",
	"Mv2Kwv63iML24FQK53/JVanIbuP7sksC0rzoACw4cvqqmMNUD0aoymkPs+3nLGKMUgEo6xJIpqZkgkR0",
	"1ASuovgsxPknBXMw8RNHgoM+Ro4djLmwHMwBHhDKggS/jdjtf0AQeSRzd22/aNt3hIVvfvlvHua9f354",
	"6fgDTPR1tqggrtCnEsczB3lT58Tq/OBNsne/zz3xPe6FeUbx7qM+p53MVjIHXzqOmK8xPM8CAuZiKP5y",
	"11U8ottAk6R/zQTk5XkGoXT/PckGiHCfoScPsqAc1+rKOQeqPQiSaIDuCCLCP0CvOGqhiUZCbpCNMFuN",
	"TkkIMxFMZgK2/5KUhBlYK/MSapXK9+UlREPNFpITbMy+MzdhDpthXoJJU/gRyNw0QWE/QrdBJMa8791b",
	"zhXf+3lJJtlUCxphJKhOz9+VXGVXSZDazf9jc8HmXO9KUJVtQFwfCnC30CNWDmLDPlH0L+vzLZ0KHTk/",
	"ystmGUpbrLAQ9Q3JHjBSxyXhhtnMSWTpNGTTfG7gZEeWWvJfEBukUf0e1+jh/sW2SS+t/Quj6wJKehSy",
	"dekvNn5y+4Mnje4nCcSTC60neaEs2VfskyfP7z2N0PRpCPlwfStMOLKMYLO6peRQs/jHRXMqJL686XwF",
	"rJReEXtaWmNsgUUpY8x2CO3oRKkwBR5wJFS1oqWy4rr7Vcerq6Juc2On0hsJmn+DtMSfKHWs8Uf+Son8",
	"70mJXJMJ+fR3S4V8WpoLmWwV/pUPuWU+5LcVqO1ERv0urAZgqYgNXTiFMilvyn8mXLs8cmMkJuNHxpuN",
	"EsGnQA5BYjvcxe6pdbPqxvFJ+0JuHBHelmkES/H+GGSoboH0PUxsAMOEIoLEhLIR0MEnOp0IvFGirkGG",
	"JFSWAILBfh9bKkqnS8SQchT2CKtXqmsZCYHJILzy5EhJF2ayc4REPBCyZxrghUphwbTKhgk9z5mqpNJo",
	"kdrZpEuCiFaQaDB8cLcoS9rS4MSun8+XLN1H/Rv9M6d/cyEf6V++/p/+pd1o6h/+D3sciV39q/q3/n19",
	"qEPSWThqXr4nKKjnWyMkljuDINHSg7xvOzeN8/3G9T7oCMqkXmY5kHOwp4bIzlcpNX9kzAxbVmS9GWrt",
	"bT5iLHTpSqapCj/boEldzxcIHJABJkFgZpfchCUj1UBzRVwnWAyNfHfUvAQmniJtXBeYK903bkLXwaW6",
	"bvDMvazK2cXKjYbVXbvkowlwZRno4Yzect/Htt7xj4EkY6aTYoGIQb1N9ddZreJFVMol6u+ReprhmgJH",
	"UNRfHsGvpHqDT1X/OUQllH9jW40eFF/Ngg5CIAwBcqhvZweUDkygHddHR9XgzIU1XE3Z3HjNVhVy5TsC",
	"ZwzkYX1Xy6EccREIaYb+yG+mtGpwPPXBDLt9kmi2JO8i8ZTzeSQjf4uK6MlsxOBFrRsEzSW8apT4SU46",
	"vup4ZrtERTWbQ6KwbgI/Iin5oWBpplHWkiy4UxBoYZgDyNBulwCQAR+lsLn7B3IhdrD97eMuaBCg/gLQ",
	"thniXKsSDHkMcaW+hHNZcggwt6wsOKQMGOylwUfoYAv9byS48mPWzGzux4butyUMemozxLK53WlGuaoy",
	"0PP+F3oe96jIDkynoE8UJKW5bIsNs/6gUrCEaw4FtosJT8SBTV2Iye4f+r9yQkWeoONjgYD+FfzmMexC",
	"Nv20OLnj6AmDfF9z00Jh+s5jZEZ6H6VI9XEOpmSqW300g+rKmjmo1FdIpl0S4Lc7J7uqA7dwKlKhMBqc",
	"h003L2X01N1FNKfSKYPg6I8/5U2G8N79cdV01d0sx3+aTwmE3ELEhkRkegxiO1PKlyqF0lolKTJcel1x",
	"3qNA9d9CeFid/27YkjYOzIwqv1FPD/8pMQd+fYH2uQG/vxhoKxJJs4UEHXRbowuqyHNb6wubxOkcBO11",
	"xBMXPUrFpp0Pww6JQuLCHFsGK4Ze3nUGZtVuFa4PoyvbAoTEmOlLRseY65AYcHt9tlHocyJ00XSsn+98",
	"1qSof94gK+Zm6unwAZ2nuDYCqXMjW/0M13P0GSBjk8wvWH2NjUgtMh3ahrLgfohI8JxHPlrQXXbA8mJ1",
	"McGu73aJjfqqMnJvGmmn5Jr45VIu7pR3qrXiTnWZkUmL60/U2yihMK5JzbqbV0KSZWvlnVJJY7qf0lWU",
	"4Oo5aP6dEZOnJpAL9CJ5l0DAkQeZZI6mtY2kxqWFXXXBYsEBnZBgiixom/G7ZPachplDahETJLVjPgMj",
	"+GZ4qHoTZaRMAQx1Cfc9feNvEY2jcXWjxl17kcaoJEYAc6f0a0CNKlduMTwBe8jBZK3WaJZpMiNA0M1o",
	"d0OjZ4XhWHqUnlT4jE6oUg7DstfZxMs6gMXzWfDm1CI45mP48IbppCOm/qXAY5SKf0VghDx0vGrDxmKO",
	"ou0jyfNmxKGamEHVL7MBVehVIEBqRWF5PiPY98NEKqJeZwG03yWculEy5GkTX+dCFZAWHrNgzthB6xKD",
	"hGwk4C5ceXAcEqPteI+6G+SEBp6aj7K9OlcfjeqTXXDlrsxQD/uvIHWzshgAWdCMB8d2Lve/SKY2o6zI",
	"2rlnvyYsdz4frKel5BCk9NzxTziCM/JZIpWiwIe9cTZk6IrdOhvU5FGGXHSzAeJVN+Y6b3GPzY+zkj8F",
	"2Zxx9G2VOJnWR1r/UwOt/x2UvzPZlQtnPHLHR6aCEzkNnPDMEGbY0Mfmr8g/OfTCP980MPrZHAS9WuxL",
	"/I9IPxW0HRYyMH8FeSLmh1k8djo1UL6HgRUOMJAiU6jQ6KiQaAdMRUaKe7DnxIeWH8KJ9R/xj/OjMDiZ",
	"zUNFYqh5Kp1y8DgOgRIqoJPREb7UklCPuSfZ1+xfGTqGqXRqwp0lWySJ+NRUqotT1GKCxXdYcVvRmPf4",
	"+Ny3aYZQVfDJ3i7PzCdQCETszQMxT8Mo+m1EYE/SQIJbXf3OAWQDk7lvLhZ5IFSGIwM6bF/V0pAilGRm",
	"MVscodwVv/cps9Cqol7LtUUzQVjtaja0/pKxUc8fbJZqemqqMnxH0u1s2kOdn9d0qG9n9iBfYstVGXXx",
	"nsV8MZ/fydey+UT7pIroSM4dHNFnnJA4KH8e+r1NUi4hH81bJcrFJP098rzHDI7S+rfyDPizqczmzkac",
	"YeXrkr0JCgDNG2Ik8Zo8e6IKvCwEEhHNhnTLZcMvu1MV398EO0lnKjncT4rmS55sGaAlKY1GM1v8IqiA",
	"TtKnOSyoSdPhY7D6DVbdOb001iqt3pZztvNBrRpj6cucJv7mKYjaWPOgZqz5UrjRlsYf3WmN6WeEpip8",
	"bJEzdZCRwYMmwIFT6sfDVfzEggsOJAM/OTQ78DronKaFR3vSJl6DyVYEgR6yqIs4MFbmtHoFDr34ShmQ",
	"sjtkCHBkUWJDk8MeMeci8nTbyd7eHGbq7/VjXzRb7zw34Qg/5RFNY0nZXYzbVJpTok2qoZ4mVXqmcl9z",
	"JNKhf69PGegjYQ2l8mZGyYKWFGSQ8TT8y2fOv5TmgESgyae7RCuusYRZZWYwkfRK6Vji89YBYQnhaZDI",
	"sRBWyT3Q1LMCv5m93gX5YjVf7hVtWEU7lXLPLpV79V69COulCqrAWs0u9qr5fh9+Suswph6DxBpmHDxC",
	"gIVVOWbjsSFyZin/Urb8NOd5W2yRfDn2F5MvNuhmEoRWh9PtI4GYq1TYyRAZ1Gh3XuyxRBcSOEAM/GZB",
	"YjvIw+QTwDYiAoupfplWny8VnQCV2rBQTxc0KeG+ixiw5OFSlUPm06IhB5aDJWnG2wwR6ZLwLIXnQApR",
	"wcFaUq5385jP+QjmBUIYmq1YtHAm315LrrWkYjbmMlIzJNLm0prpv4qi/w2LoidvQ6KyteT+X7OY5eCk",
	"Z6OugmwFVFyl2KKttbPv6ZdEp8Frez+sHlBgrDQpX4IGwkQWHGIHgYFDez0TuBJauNJdggZZ8FFlSvNh",
	"5n8+znF34fqJlZmXvgh4YTyF4YuAK+AK3pTsOZCMdN02XQ8nkuEaDBN7YBLcY8e21NOLSu4JlmNWU84W",
	"CtmFpZSyJfj9jkezX/thlkeCTynxKChNQ2B3WdbI6nLlyKNLxnWwhUw64FIVe5WOmvD8sCtFy8RvyfdP",
	"7BhsgNckvVBnPK5C+fd4uZPpJPam6GLwNiRQyc8ZQanD331UolVPNzwrquwR990VZBXQUdAU+FwSdePs",
	"6GL3uNE5Vjb0eKH2ISxWqruVYqVWr9uoZNvlcnmnZhVrdrlQK1aq9VK12ivmS/U8rPaqtXytn4eFnVq+",
	"XCuhsi3/UYXlfmLew9LT+X0nEA9cu7Lsk3ZtrGC37zmfxli/9pjK7fUdT2sZ7wrihBwl5zLsmS9KWZhl",
	"BxvX0UwUXZm4PF2ZIyiZsLKbGI+bYAgFuoR6jGCJperJBFipa32l+Wk+4TlYbSK9zCF0mV6oyoFtpByG",
	"LZOmUwUFluTA26T/5Kkseb5Brn8bkjCrnpsh599xNzrHZqMFY3xbBvZ8PsSymI+1BRVWTXS5bh59dp6C",
	"V2BWu5ZCK3zyZJsd2JjtJtsljaBCrCoUoiWMj6bC3cc0+Dgreqb+MsXWPoLZOlRoZpf00EwlUAKJKjmi",
	"R3S1cBGPs6PM1uGbHkMWspW6jHWNFe2hh1wF6ks1sEfHiZH0kVJ8f14Fvq0r7m2W2DfwBqaIpgn0Nbsx",
	"40ShortEt51V45sLSrs8AiM0DSunyCtg5v5XqlNcNY/deplM+ITE5dEluLzdO2s1wenBA9g7u2ieqs9d",
	"0iXuVet876hhdSy6d9DYP+vXH45H6O2kCm2n/TCpwaOjlnMCHVE/eS6+5vaKp5+HrX7Lfz0S3t1zDXXJ",
	"2fVg/7ZWfYY3Fe9uv+Ietk9K3ggRdJ2zbtyXl6vR+fSKD78U6dWXycHbbadXaJ63m/3m0WD0pX5V7JK3",
	"xxFrWU12mL8qTthpz4G+Pbz9jO8gaexzt1B/OHjhvUrjtlSzxS1rl64e7PvBzvXnL/iyf1e/7pLTveeb",
	"fGl8t3dhtzv8obRzBpuk2vIKF2Ov3jqguRY6uHsovLjNi8sGPM33To5Lfn9QbvpoxD/fdLpkcnV/g5pn",
	"r/7jWfWi/YVeXJ5Oxu2r/mtvUPiyXx/7j/lT8Zyzzo+Lr9DPv7q84e8cn3hoNL64vH51umT6Ip6nj31G",
	"7zA6nHqTx8H4aiIIaddzg86Bnzu5u2EP+UrRPbi9qTWtXq08so4Pbw777ZFDRke5Lsn3b8uNa1jJl49L",
	"r8/5keih0vjUuvxCLy/80707ftwZ5/O3Rw+N6SXyp5/rNes293AwbNdGpc7d6XOXVFHrcTDF7Yv8xCk8",
	"HO1fn1q+MxnxncZn3xkNCvSmV+alN/dxfJmvHdGb1/ty8RmeVu47n8+Hjwh1Sb2a/0Lvhj2rcOp1Pj/3",
	"H+kzZwfisX7Zu338/DA+rF97zL5vsOfj3smoeOJdnzZeb4av/KrB94ZHhS7Jn/mvxXvY3ssPiq3KpdW2",
	"T3LWyzPN1y2LPe998fHrPcMV7O+0v3j1l5tcv/N27nK7NSD13MvjaZfg+pXv9P1azX8Z3ucmotgTBIvB",
	"NX95Hr62/eeH2/JjrzwcicP68PQ29+VLrVx8GZ5VTieN68ZVY69LxP7h0eP99dhyDwan++3CaadRf3Tv",
	"Rr3SyfDspl04+7I3hfeFoUWcRvC7dXwyhu7ds92sjLvEcq3P+OrkYm+vvddsNMqH+OAAHVddNjw8rvl3",
	"/Oqs3S7mHyrW45C8PtQPG66ioebRpH7YnIxaXbI3aR0dXtGTZoM39/Yemo3JQfN4cNA8LDcazcHoatb7",
	"8/lDI1fbe/AGzrTTeHw4Hj5PT4ddkvvcr75d9u/GveNi/uClNGrVLg73zvPk7MvnvduC6487n19u/E7p",
	"/oztldzSke8I7/T64OT0TLiVg/0uKbCjty8NelOYejsPrfpZY99uN5sX0+fGM6f3t/Xaw63f/JzrkWd2",
	"g66LZ9cXzf70slmr3u/UK/jirkvcSudzj1/tT2rN4hlz7Ea73N736fSx0MHiCD6WT6/O7sTnmwNYKGP+",
	"0DlqPr/R2uVD/a50cjGq5Ltk8HI/qBfPcz23ePDWqd3US/cH+72CM34ut5zx66D1cooGhcLbl4dXlz10",
	"Hk9Omv3xW/+zc96p+q+D4y55fs2d5KfOY/EM945Y9ajRmF7s3N6zxmNn0mnnD6znm/rkoEleR519f/ri",
	"3k/uxud7X/yD1l39ApUeuqSNbwv9k/M6t2v7Hj98rbQ/f7FJm1x1Ph+z55vL0/2Se8+chk0Obob2w139",
	"+XHk3Q/3p7yU29lBF10yHOXZGZnmn88nI+j3c/i2fmFVv4zbo+ez6/bJoHK7c3c6PfHv78Xb5At5bp9X",
	"7q8P915Oy/yRuu12l/RF7+a48Lky7V3f5xql8V4Pvl7fF0Xt9u382XpDo87jAYZn5ztnuWPrpNm6Llwd",
	"1qv14r7dcA4Od+wuGRUHV/ihc9WA8CR/ctJ4Ox5fj65Pzs4Gp8WHqwd8fH43LYrSyfSwzxl0K5NO8/6i",
	"P7xErenZ3s3jSZeMmXfuXPZQn9/sVGo3/eLeecsfvD2yZuXudb9zOnocXA8Ld0fjTuuKNKdvo6tp9eC2",
	"+HLp4fvKjuRRw8vWl0d2Sq3T0ulZZyeH306ubq4d8dxu/N4lv1/2b2rqISL9FNGKq2dJnUDK0BPnTvIl",
	"/ava7Prn8lY6Cn7U83nRsmmJ9jg5XqCq69pqyt0SkYoglwINB0rliuTrqJJtXfJbECf2KbF820LGRlDe",
	"m25ZovDHeljiThSwxIeyYeEH89z2dnp1oijZsO3QhRtY483DeNAXQ8rwG7KVPrNYPWCjd+4anXssRhfH",
	"5dt6rXxg871bMhW9Um8yvh4Mjp0rp/fwxamRQn68s6S+eGIRglv9OmCo/ugsNPNsuTxScfuV7WKyPp6e",
	"q5ANiack7biDJD0aExb/8+Lrv6dM2/LCZw15vJWWZmiQQFc72blan8RdFnS03ZiD/wGT0KCsInhV8zTo",
	"+ULlTUniNTYhPhduvZ7AfnItuRAJ60vJze/t9gXltPlbvYGo8YqJZtKS+NV7EPvnh1tWlgtM6u8qLLdx",
	"OYMfUJYA9KaRxxMTiukHxY/t5AuUtHSXwg+pV7AWGtJXkZx8a2BcyEebwiLbroVEV3DYFiuJV0PUXLZo",
	"KNygrKgeIWoL03ehhZiwt+gsm6+ypi0xEy7SHKO2H6YRriwyPlfI8zstjgvDLId+fqGLDg1f0CfzgAac",
	"82WtvuLndyGhiB7Rr3V5lG8xasyrNgesJfBY11AzwkIs0ZMjiyGR0c/dhhJo+LxsUl1SyNFToj1v0Zy3",
	"gVQbhBXEhltW/YmyASQRQ2008rScLxXLyVE11nqRL/Q49R04CEo6sKGli4zoQIhIWa+gCgN0ODWVog2D",
	"4qBlVjQntC5bU7zOWfRlo9m2ZiWtRhC7Fq9zl0kMb+n5MxGDIbLBkc1JuoRuIuV+t4hPDLqtiVAkwtNQ",
	"rYgmJMIDQaOYepDPEsrEMANdxLAFsx6lTpYIT6pnqXSqsOrzVvpEtOTx8iiFoFU6uDDUJXJ704wJtLed",
	"3AGU54xsFuu96I8j042f453PI1zbp1ParstC1Ze1c7z5DG3XZcmjU+u6JYQDr+uyEAe6rsMyt+m3r8mc",
	"J1CZ9YuBi0mWqroJ5oAPqe/YgCEVdNVTteMv+kp0X9wknbOqYmeFSpJL2PssUOO6CBIT3wkdByQ0BPrk",
	"8S6BDGnGp1XihXlh2NZwyTGmKtJFu5QkwF3CfAfpSvIM9SlDaTBBYAjHYT0ddZqByuGTq+shACcwKCOI",
	"BcCcfBRd4lHOcU8XRXTxqwovdKGwhtq3ZfYDCDpQirxkyiHtLHO9RnJxt3niei6fa2OS2rDHfD2HLQhq",
	"wx7JD5VtTBsbtl/iAN+CaqMPXm+fshcm/W2S3m5yiHV++7L3Fk04RXBsvs4dsC2T9JhPyLJMvFhK88K5",
	"3XpB78w+T44qmRvy69Kra3lGYZaXwlS+IHEwmn1HLZw1LEZXUpII9B0va+oPmMdTklFobE/bVBEJX+dJ",
	"UPPUx8Imr8AtyN8bGdvO2dHpAWs/4M/t9u3EP4bXjRP3+oy23q77xZf9or1fecvv3bzmqq+r8s+iyRuI",
	"FZINTEbqX3xfOohq1A0AF5CpSGAxBB+qH9LgQ+WDCrH/UOx9CB9U6SEgt0eFiHcJJAARi009oQwqeqQs",
	"uJBceYIj77D0EBDmDUZVhHRWjLZLwn7x4OHl+spmUWxKDLd8hsW0I4+63vY9BJk+Kz31r8NgupP7Gyk0",
	"q5ZSmNftwlGlLqTrcWPSp0kpNrpElKDGyq1KtekwUZ3CzrOpWMij3sRUw4PWEIGiSq9TCkPoDZlMJlmo",
	"PisXhOnLc2et5sF55yBTzOazQ+E6WmgV6iBcdPbU9CaZmgFVCw1AD0eCwnZTxeBxIflhN1XK5rOFlC5N",
	"q9CUsxxKEM/9ge1vilqSqvUdIR19pXmmqtsHDKOT50YFiyMRPCipjWswfHzZCD/6TYeIVZ4yZbCcFRlQ",
	"BXcwJUCxWGTrrPawjHjL1qA0JcSdgH17kEEXCaVq/DPhafWgVEgAvKBgoOoFYqLOnhgGsXS7wTO3wYnT",
	"Sp9mn3EqLBRLqFyp1jKovtPLFIp2KQPLlWqmXKxWK5VyOZ/P59fHx0txkhnLptqMYj4fyf8xua+OiVbJ",
	"PZsq7DOAVooDESx9W6xJH8WJPCLlHzi1SelfnLRFtNBpTgbAtp668POnbviq6vIIKccP1oDo2Us/f/Zb",
	"MvPdyBPoISbPBgjPtoak/GdAMiJ0Qua2oPJn7P4tQa+ezjJRZSIAtdSTb3aMhSsqDpj3P79KGgmjvVWR",
	"jCgTUswrPE9qnFzwh6qXnPTqblMXCoOAoEnQNQ08KpeOg3QYboqSKtvxGDEYMHfF742Kp56d1z46zKIK",
	"H19kXJeUC8OrDZNBXOxRe/rjKF6PHj77H78+JTP7tsBvCj969padtPXmo6qMo8QPZP9lTIcF+PnFeX5x",
	"no05j2EaSZyG59YKTkE57KCHMp1Mg/JGofyUDp/mTneJUoKcqX5vVsnnfeXPTJaJ9MBn+iGGnydURKZJ",
	"wPP8Mn/R2C8a2/J2XzxCMUr7MWrKFppJgMk1Kkm0otVmSkk48H+ZWhLDVMI5iuPll2ryi3n9TVWTRElB",
	"8i9tconqJwmagmwyUxc24CcRZvVvxEV+gpYTwYwa+M/WcyLzh2FpCUdK1QpFk1lR854qqamLSi/RfgR6",
	"FTllMY3DM4/ajblX+UdNkESb32LysURL7DmPFQTgmEJa33OL9zHBfBi5xMHKOxyL2dWdVrq7cn66SMBY",
	"QCDsUV+YbDDuO2KllC3B/3XJr1cTJJ6WkIY8AuGrK9pvHppiMAGE6nfXLd+BzNRaBb+JIfUHQ+O5Pulc",
	"nH/K/scR0pF6UmQQhBQEpzyJjFxIcB9xsZ6WwpYbkNM1Ej4jXKWrBv0UMMraZdgZMaSi+LupOh02tqgi",
	"rLAeo9m+oOo2FCDq+DBFlHXyByQ583cmGC5bWUGK7RAFv+hxLT3OkLWEKGPbvUCY/5m0FiePDYguUipj",
	"Nc2FtdMkyS3QmX7wCL1CS8QuIqbID9nARrq8KY3RWuhkU+XqV1FGAOcvwlhPGOGD8UvoItjKbejil5L6",
	"S0n9d1NSF3jTen7He9RdLmAEwgIEOkoxXraer5EbumSuOWRhG1XhflZkf6nJbe+iveXlL2HSoY2azYFg",
	"jP8S05ta7RJOpz7+t13/s0XPk4KNPE6dMcr1HB95zLwlvNxss2/a74XNf44RJJhnK19v/idMv9z+EbSZ",
	"5d85OPC6/olXZbCDv9y+ixfm3+XWCo6SrqDEdGx4SJHGRRRNKI3eVwsXx36k4c/2ly7MlUQokTYgloH7",
	"NxMsoOOEz/IEVS6Bnbi6KbCDTFq5d2rWlZumYDe7NXfVJy151iSnys0vC0+PtFP16H/q/TtbQxK7CD2f",
	"Bhm/+NRfI9hrCvj7ifWzN9clHYaJNcFpmpHZeh86JGEh6YCgNWSzitS9KVDyazKhbu6xQqb5u0Tv0p8s",
	"SC/dSvUBRH/7RcW/qHgbKkaLJ0hSbhjAv/yGvDBN3nnu53MrFhZqQFG8QOrqcgijp/8dLSErlyNRr4uw",
	"5KJ1Rpbrf/GqJT9J+Usue/Mnq4BL6rMkbJZuCQJIdN5RoBPas4Iqf6payAOgfimFf1OlsBMWRzKHCNkx",
	"PwolEZEoVlpJAxTWJ1iQTtrmjXxV5ART8gmEj4fF07agh7PqNYIh7uuSGdDDOf1IofJhIpYx9iSWGxeV",
	"FjJHGwIOMBmsmoALOEDvnMbSj4eaN/zDadaN8/Xb/w8AAP//DrWwbzDiAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
